/* gcc */

/*
 * Problem:   THEATER
 * Contest:   UOI-2005 (Rivne)
 * Author:    Bogdan Yakovenko
 * Date:      March, 2005
 * Language:  C++
 * Compiler:  gcc 3.x
 * Algorithm: Algorithm approximately finds required areas.
 *            
 * Remarks: 
 *   This program might help you to find out correct answers for tests.
 * 
 *   
 *   
 */
#include<fstream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<iostream>
using namespace std;
const double EPS = 0.000000000001;
double a,b,R,H;

int N,M;


struct Cpoint
{
	double x;double y;
};

vector<Cpoint> point;
vector<Cpoint> st;
double S,spam,e;

double operator^(Cpoint &a,Cpoint &b)
{
	return a.x*b.y-a.y*b.x;
}

double sqr(double x)
{
	return x*x;
}
int next(int i)
{
	if(i==N-1) return 0; else return i+1;
}

void makeclws()
{
	S = 0;
	for(int i = 0;i<N;i++)
	{
		S+=point[i]^point[next(i)];
	}
	if(S<0)
	{
		reverse(point.begin(),point.end());
	}
//	cout << "S = " << S << endl;	
	
}

void chopup()
{
	double _a,_b,_c,zzz,kkk;
	Cpoint v1,v2,res;
	vector<Cpoint> z;
	z.clear();
	for(int i=0;i<N;i++)
	{
		_a = point[next(i)].y-point[next(next(i))].y;
		_b = point[next(next(i))].x-point[next(i)].x;
		_c = point[next(i)].x*point[next(next(i))].y-point[next(next(i))].x*point[next(i)].y;
		v1.x = point[next(next(i))].x-point[next(i)].x;
		v1.y = point[next(next(i))].y-point[next(i)].y;
		zzz = sqrt(sqr(v1.x)+sqr(v1.y));
		v1.x /= zzz; v1.y /= zzz;
		v2.x = point[i].x-point[next(i)].x;
		v2.y = point[i].y-point[next(i)].y;
		zzz = sqrt(sqr(v2.x)+sqr(v2.y));
		v2.x /= zzz; v2.y /= zzz;
		res.x = v1.x+v2.x;res.y = v1.y+v2.y;
		kkk = (R*sqrt(sqr(_a)+sqr(_b))-_c-point[next(i)].x*_a-point[next(i)].y*_b)/(_a*res.x+_b*res.y);
//		cout << "kkk == " << kkk << endl;
		if(kkk<0)
		{
			cout << "SUXXXX\n";
		}
		res.x *=kkk;res.y *=kkk;
		res.x +=point[next(i)].x;res.y += point[next(i)].y;
//		cout << res.x << " " << res.y << endl;
		z.push_back(res);
		
	}
	point = z;
}

bool czero(double x)
{
	if(fabs(x)<EPS) return true; else return false;
}
		
int sign(double x)
{
	if(czero(x)) return 0;
	else if(x<0) return -1;
	else return 1;
		
}
	
bool inp(int k,double x,double y)
{
	if((st[k].x-H/2-R <= x+EPS && st[k].x+H/2+R >= x-EPS && st[k].y-H/2 <= y+EPS && st[k].y+H/2 >= y-EPS) 
	|| (st[k].x-H/2 <= x+EPS && st[k].x+H/2 >= x-EPS && st[k].y-H/2-R <= y+EPS && st[k].y+H/2+R >= y-EPS))
	{
		return true;
	}
	else if(sqrt(sqr(st[k].x-H/2-x)+sqr(st[k].y-H/2-y))<=R+EPS || sqrt(sqr(st[k].x+H/2-x)+sqr(st[k].y-H/2-y))<=R+EPS || 
		sqrt(sqr(st[k].x+H/2-x)+sqr(st[k].y+H/2-y))<=R+EPS || sqrt(sqr(st[k].x-H/2-x)+sqr(st[k].y+H/2-y))<=R+EPS)
	{
		return true;
	}
	else return false;

}

double getSP(double x1,double y1,double x2,double y2)
{
//	cout <<  x1 << " " << y1 << " " << x2 << " " << y2 << " " << endl;
	if(fabs(x2-x1)<e)
	{
		spam += (x2-x1)*(y2-y1);
	//	cout << x1 << " " << y1 << " " <<x2 << " " <<y2<< endl;
		return 0;
	}
	int tmp;
	for(int i =0;i<M;i++)
	{
		if(x1<=st[i].x-R-H/2+EPS && x2>=st[i].x+R+H/2-EPS && y1<=st[i].y-R-H/2+EPS && y2>=st[i].y+R+H/2-EPS)	//the hole inside the square
		{
//			cout << x1 << " " << y1 << " " <<x2 << " " <<y2<< endl;
			
			return getSP(x1,y1,(x1+x2)/2,(y1+y2)/2) + 
			getSP(x1,(y1+y2)/2,(x1+x2)/2,y2) +
			getSP((x1+x2)/2,(y1+y2)/2,x2,y2) +
			getSP((x1+x2)/2,y1,x2,(y1+y2)/2);

		}
		else 
		{
			tmp = 0;
			if(inp(i,x1,y1)) tmp++;
			if(inp(i,x1,y2)) tmp++;
			if(inp(i,x2,y2)) tmp++;
			if(inp(i,x2,y1)) tmp++;
			if(tmp == 4)
			{
				return 0;
			}
			else if(tmp>0)
			{
				return getSP(x1,y1,(x1+x2)/2,(y1+y2)/2) + 
				getSP(x1,(y1+y2)/2,(x1+x2)/2,y2) +
				getSP((x1+x2)/2,(y1+y2)/2,x2,y2) +
				getSP((x1+x2)/2,y1,x2,(y1+y2)/2);

			}
			else 
			{
				if((st[i].y+H/2>=y1-EPS && st[i].y+H/2<=y2+EPS && inp(i,x1,st[i].y+H/2))||
				(st[i].y+H/2>=y1-EPS && st[i].y+H/2<=y2+EPS && inp(i,x2,st[i].y+H/2))||
				(st[i].x+H/2>=x1-EPS && st[i].x+H/2<=x2+EPS && inp(i,st[i].x+H/2,y1))||
				(st[i].x+H/2>=x1-EPS && st[i].x+H/2<=x2+EPS && inp(i,st[i].x+H/2,y2))
												
	
				/*x1+R<=R+EPS && (inp(i,x1+R,y1) || inp(i,x2,y1+R) || inp(i,x2-R,y2) || inp(i,x1,y2-R))*/)
				{
					return getSP(x1,y1,(x1+x2)/2,(y1+y2)/2) + 
					getSP(x1,(y1+y2)/2,(x1+x2)/2,y2) +
					getSP((x1+x2)/2,(y1+y2)/2,x2,y2) +
					getSP((x1+x2)/2,y1,x2,(y1+y2)/2);
				}
			}
			
		}
	}
 	cout << x1 << " " << y1 << " " <<x2 << " " <<y2<< endl;
	return (x2-x1)*(y2-y1);
}

double getS(double x1,double y1,double x2,double y2)
{
	if(fabs(x2-x1)<e)
	{
		spam += (x2-x1)*(y2-y1);
		return 0;
	}
	double _minx,_maxx,_miny,_maxy,_a,_b,_c;
	int kol1,kol2;
	int ppp1,ppp2,ppp3,ppp4;
	kol1 = 0;kol2 = 0;
	for(int i=0;i<N;i++)
	{
		_minx = min(point[i].x,point[next(i)].x);
		_miny = min(point[i].y,point[next(i)].y);
		_maxx = max(point[i].x,point[next(i)].x);
		_maxy = max(point[i].y,point[next(i)].y);
	//	cout << "minX =" << _minx << " miny =" << _miny << endl;
		if((x1-EPS<=_minx && _minx<=x2+EPS) && (x1-EPS<=_maxx && _maxx<=x2+EPS) &&
		   (y1-EPS<=_miny && _miny<=y2+EPS) && (y1-EPS<=_maxy && _maxy<=y2+EPS))
		{
		   kol1++;
		}
		else if((x1<=_maxx+EPS) && (x2>=_minx-EPS) &&(y1<=_maxy+EPS) && (y2>=_miny-EPS))
		{
		    _a = (point[i].y-point[next(i)].y);_b = point[next(i)].x-point[i].x;_c = point[i].x*point[next(i)].y-point[next(i)].x*point[i].y;
		    ppp1 = sign(_a*x1+_b*y1+_c);
		    ppp2 = sign(_a*x1+_b*y2+_c);
		    ppp3 = sign(_a*x2+_b*y2+_c);
		    ppp4 = sign(_a*x2+_b*y1+_c);

		    if(!(ppp1 == ppp2 && ppp2 == ppp3 && ppp3 == ppp4))
		    {
		    
			kol2++;	
		    }
		}
	}	
//	cout << "kol1 == " << kol1 << "kol2 == "<< kol2 << endl;
	if(kol1 == N) // All points are in square
	{
		return getS(x1,y1,(x1+x2)/2,(y1+y2)/2) + 
			getS(x1,(y1+y2)/2,(x1+x2)/2,y2) +
			getS((x1+x2)/2,(y1+y2)/2,x2,y2) +
			getS((x1+x2)/2,y1,x2,(y1+y2)/2);
	}
	else if(kol2+kol1 >0) // there are some intersections between polygon and square
	{
		return getS(x1,y1,(x1+x2)/2,(y1+y2)/2) + 
			getS(x1,(y1+y2)/2,(x1+x2)/2,y2) +
			getS((x1+x2)/2,(y1+y2)/2,x2,y2) +
			getS((x1+x2)/2,y1,x2,(y1+y2)/2);
	}
	else 
	{
//		cout << "...when the music's over...\n";
		double SP;Cpoint tmp1, tmp2;
		SP = 0;
		for(int i =0;i<N;i++)
		{
			tmp1.x = point[i].x-x1;tmp1.y = point[i].y-y1;
			tmp2.x = point[next(i)].x-x1;tmp2.y = point[next(i)].y-y1;
			SP += fabs(tmp1 ^ tmp2);
		}	
		if(czero(S-SP)) // Inside...
		{
//			cout << "now. now? now!";
			return getSP(x1,y1,x2,y2);
		}
		else //Outside...
		{
			
		//	cout <<  x1 << " " << y1 << " " << x2 << " " << y2 << " " << endl;
			return 0;
		}
		
	}
}

double ans;


int main(void)
{
//	cout << "7 11 7 11\n";
//        e = 0.05;
	e = 0.0005;
	spam = 0;
	ifstream in("THEATER.DAT");
	a = 100;b = 100;
	in >>  R >> H >> N >> M;
	Cpoint tmp;
	for(int i=0;i<N;i++)
	{
		in >> tmp.x >> tmp.y;	
		point.push_back(tmp);
	}
	for(int i=0;i<M;i++)
	{
		in >> tmp.x >> tmp.y;
		st.push_back(tmp);
	}
	makeclws();
	chopup();
	makeclws();
	ans = getS(0,0,a,b);
	ofstream out("THEATER.SOL");
	out << ans+spam/2 << endl;
	out << S/2 << endl;
	out << spam << endl;
	return 0;

}



